package org.jeecg.modules.resrun.sdk.utils;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;
import java.util.Map;
import org.apache.http.HttpEntity;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;

public class HttpUtils {

   public static final String TOKEN = "token";


   public static void main(String[] args) {
      String url = "https://scpic.chinaz.net/files/default/imgs/2023-01-03/e0f209137275d9b1.jpg";
      download(url);
   }

   public static String executeGetMap(String url, String jsonParam, Map headers) {
      String result = "";
      CloseableHttpClient http = HttpClientBuilder.create().build();
      HttpGet httpGet = new HttpGet(url);
      if(headers != null) {
         Iterator response = headers.keySet().iterator();

         while(response.hasNext()) {
            String e = (String)response.next();
            String value = (String)headers.get(e);
            httpGet.addHeader(e, value);
         }
      }

      CloseableHttpResponse response1 = null;

      try {
         response1 = http.execute(httpGet);
         HttpEntity e1 = response1.getEntity();
         result = EntityUtils.toString(e1);
      } catch (Exception var17) {
         var17.printStackTrace();
      } finally {
         try {
            if(http != null) {
               http.close();
            }

            if(response1 != null) {
               response1.close();
            }
         } catch (Exception var16) {
            var16.printStackTrace();
         }

      }

      return result;
   }

   public static String executeGet(String url, String jsonParam, String cookie) {
      String result = "";
      CloseableHttpClient http = HttpClientBuilder.create().build();
      HttpGet httpGet = new HttpGet(url);
      httpGet.setHeader("token", cookie);
      CloseableHttpResponse response = null;

      try {
         response = http.execute(httpGet);
         HttpEntity e = response.getEntity();
         result = EntityUtils.toString(e);
      } catch (Exception var16) {
         var16.printStackTrace();
      } finally {
         try {
            if(http != null) {
               http.close();
            }

            if(response != null) {
               response.close();
            }
         } catch (Exception var15) {
            var15.printStackTrace();
         }

      }

      return result;
   }

   public static String executePost(String url, String jsonParam, Map headers) throws Exception {
      String result = "";
      CloseableHttpClient http = HttpClientBuilder.create().build();
      HttpPost httpPost = new HttpPost(url);
      StringEntity entity = new StringEntity(jsonParam, "utf-8");
      entity.setContentEncoding("UTF-8");
      entity.setContentType("application/json");
      httpPost.setEntity(entity);
      String responseEntity;
      if(headers != null) {
         Iterator response = headers.keySet().iterator();

         while(response.hasNext()) {
            responseEntity = (String)response.next();
            String e = (String)headers.get(responseEntity);
            httpPost.addHeader(responseEntity, e);
         }
      }

      CloseableHttpResponse response1 = null;
      responseEntity = null;

      try {
         response1 = http.execute(httpPost);
         HttpEntity responseEntity1 = response1.getEntity();
         result = EntityUtils.toString(responseEntity1);
      } catch (Exception var18) {
         var18.printStackTrace();
      } finally {
         try {
            if(http != null) {
               http.close();
            }

            if(response1 != null) {
               response1.close();
            }
         } catch (Exception var17) {
            var17.printStackTrace();
         }

      }

      return result;
   }

   public static String executePost(String url, String jsonParam, String cookie) throws Exception {
      String result = "";
      CloseableHttpClient http = HttpClientBuilder.create().build();
      HttpPost httpPost = new HttpPost(url);
      StringEntity entity = new StringEntity(jsonParam, "utf-8");
      entity.setContentEncoding("UTF-8");
      entity.setContentType("application/json");
      httpPost.setEntity(entity);
      if(cookie != null && cookie.length() > 0) {
         httpPost.setHeader("token", cookie);
      }

      CloseableHttpResponse response = null;
      HttpEntity responseEntity = null;

      try {
         response = http.execute(httpPost);
         responseEntity = response.getEntity();
         result = EntityUtils.toString(responseEntity);
      } catch (Exception var18) {
         var18.printStackTrace();
      } finally {
         try {
            if(http != null) {
               http.close();
            }

            if(response != null) {
               response.close();
            }
         } catch (Exception var17) {
            var17.printStackTrace();
         }

      }

      return result;
   }

   public static byte[] download(String url) {
      byte[] fileByte = null;
      CloseableHttpClient httpClient = null;
      HttpGet httpGet = null;
      CloseableHttpResponse httpResponse = null;

      try {
         httpClient = HttpClientBuilder.create().build();
         httpGet = new HttpGet(url);
         RequestConfig e = RequestConfig.custom().setConnectTimeout(15000).setConnectionRequestTimeout(15000).setSocketTimeout(15000).setRedirectsEnabled(true).build();
         httpGet.setConfig(e);
         httpResponse = httpClient.execute(httpGet);
         int statusCode = httpResponse.getStatusLine().getStatusCode();
         if(statusCode == 200) {
            HttpEntity httpEntity = httpResponse.getEntity();
            InputStream inputStream = httpEntity.getContent();
            if(inputStream != null) {
               fileByte = org.apache.commons.io.IOUtils.toByteArray(inputStream);
            }
         }
      } catch (IOException var17) {
         var17.printStackTrace();
      } finally {
         try {
            if(httpResponse != null) {
               EntityUtils.consume(httpResponse.getEntity());
               httpResponse.close();
            }

            if(httpGet != null && !httpGet.isAborted()) {
               httpGet.releaseConnection();
               httpGet.abort();
            }

            if(httpClient != null) {
               httpClient.close();
            }
         } catch (IOException var16) {
            var16.printStackTrace();
         }

      }

      return fileByte;
   }
}
